IMPLEMENTATION MODULE MetrGType; 

FROM YaflType         IMPORT TypedNonTerminal;
FROM YaflPredefined   IMPORT PredefMethod,
                             PredefItems, 
                             PredefClass,
                             ThisDataItem;
FROM YaflClasses      IMPORT ClassDeclaration;
FROM YaflDeclarations IMPORT SingleDataItem, ConstDeclaration;
FROM YaflDictionary   IMPORT MethodReference, EntryReference,
                             CallReference,
                             CallDictionary;
FROM YaflParser       IMPORT NonTerminal, Walker, LimitedWalker;
FROM Streams          IMPORT StdOut;
FROM YaflLex          IMPORT LexicalAnalyzer;
FROM YaflParamClasses IMPORT ClassActual;
FROM YaflCfg          IMPORT CurrentSpot, YaflCfg;
FROM YaflError        IMPORT WarningHandler;
FROM YaflMetImplementation IMPORT MethodImplementation;
FROM YaflSystem IMPORT SystemMethod;
FROM YaflClImplementation IMPORT ClassImplementation;

  CLASS MetrIntLiteralCodeGenerator;
    INHERITS IntLiteralCodeGenerator(CGcContext);
    
  END MetrIntLiteralCodeGenerator;
  
----------------------------------------------------

  CLASS MetrRealLiteralCodeGenerator;
    INHERITS RealLiteralCodeGenerator(CGcContext);
    
  END MetrRealLiteralCodeGenerator;
  
----------------------------------------------------

  CLASS MetrStringLiteralCodeGenerator;
    INHERITS StringLiteralCodeGenerator(CGcContext);
    
  END MetrStringLiteralCodeGenerator;
  
----------------------------------------------------

  CLASS MetrBooleanLiteralCodeGenerator;
    INHERITS BooleanLiteralCodeGenerator(CGcContext);
    
  END MetrBooleanLiteralCodeGenerator;       
  
----------------------------------------------------

  CLASS MetrVoidLitCodeGenerator;
    INHERITS VoidLitCodeGenerator(CGcContext);
    
  END MetrVoidLitCodeGenerator;
  
----------------------------------------------------

  CLASS MetrExpressionCodeGenerator;
    INHERITS ExpressionCodeGenerator(CGcContext);
    
  END MetrExpressionCodeGenerator;
  
----------------------------------------------------

  CLASS MetrActualCodeGenerator;
    INHERITS ActualCodeGenerator(CGcContext); 
    
  END MetrActualCodeGenerator;
  
----------------------------------------------------

  CLASS MetrInstTypeCodeGenerator;
    INHERITS InstTypeCodeGenerator(CGcContext);

  END MetrInstTypeCodeGenerator;
  
----------------------------------------------------

  CLASS MetrDesigElementCodeGenerator;
    INHERITS DesigElementCodeGenerator(CGcContext);
    
  END MetrDesigElementCodeGenerator;
  
----------------------------------------------------

  CLASS MetrDesigCodeGenerator;
    INHERITS DesigCodeGenerator(CGcContext);
    
  END MetrDesigCodeGenerator;
  
  
END MetrGType;
